/**
 * Informatique Industrielle et Java
 * chapitre 5
 * Projet: lecture et ecriture sur un port de communication
 *
 * Cette classe coute les vnements qui proviennent des boutons
 * ouvrir et fermer, elle utilise la mthode getSelectedIndex
 * de l'objet de type JList pour dterminer le port concern
 *
 * @author F.Mallet
 * @version 2003.04
 */
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JList;

public class Ecouteur implements ActionListener {
	// La JList qui contient les ports accessibles
	private JList liste;
	
	// Le responsable de la liste de ports. Il est utilise
	// pour ouvrir ou fermer le port
	private PortOrganisateur organisateur;
	
	public Ecouteur(PortOrganisateur organisateur, JList liste) {
		this.organisateur = organisateur;
		this.liste = liste;
	}
	
	// implmente l'interface ActionListener
	// Cette mthode est invoque  chaque que les boutons ouvrir
	// ou fermer sont cliqus. 
	public void actionPerformed(ActionEvent ae) {
		int portSelectionne = liste.getSelectedIndex();
	// Si aucun port n'a t slectionn, portSelectionne vaut 1
		if (portSelectionne == -1) {
			// Alors on affiche un message d'erreur
			System.err.println("Aucun port n'a t slectionn");
		} else {
		// Lorsqu'un mme ecouteur de type ActionListener reoit des vnements 
		// de plusieurs metteurs, la mthode getActionCommand permet de determiner
		// l'metteur. Dans le cas de bouton, la mthode getActionCommand retourne une
		// chane de caractre qui reprsente le texte du bouton. Cette valeur peut
		// tre personnalise avec la mthode setActionCommand
			if (ae.getActionCommand().equals("Ouvrir")) {	
		 		organisateur.ouvrePort(portSelectionne);
			} else if (ae.getActionCommand().equals("Fermer")) {
				organisateur.fermePort(portSelectionne);
			} 
		}
	}	
}
