/**
 * Informatique Industrielle et Java
 * chapitre 5
 * Projet: gestion de conflits sur un port de communication
 *
 * Cette classe coute les vnements qui indique que le texte 
 *  envoyer sur le port slectionn a t saisi
 *
 * @author F.Mallet
 * @version 2003.04
 */
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JList;
import javax.comm.CommPort;
import java.io.PrintWriter;
import java.io.OutputStreamWriter;
import java.io.OutputStream;

public class Ecrivain implements ActionListener {
	// La JList qui contient les ports accessibles
	private JList liste;
	
	// Le responsable de la liste de ports. Il est utilise
	// pour ouvrir ou fermer le port
	private PortOrganisateur organisateur;
	
	public Ecrivain(PortOrganisateur organisateur, JList liste) {
		this.organisateur = organisateur;
		this.liste = liste;
	}
	
	// implmente l'interface ActionListener
	// Cette mthode est invoque  chaque que les boutons ouvrir
	// ou fermer sont cliqus. 
	public void actionPerformed(ActionEvent ae) {
		int portSelectionne = liste.getSelectedIndex();
	// Si aucun port n'a t slectionn, portSelectionne vaut 1
		if (portSelectionne == -1) {
			// Alors on affiche un message d'erreur
			System.err.println("Aucun port n'a t slectionn");
		} else {
			try {
				envoieTexte(getOutputStream(portSelectionne), ae.getActionCommand());
			} catch (Exception ex) {
				System.err.println("Erreur flot de sortie:"+ex.getMessage());
			}			
		}
	}
	
	private OutputStream getOutputStream(int portIndex) throws Exception {
		CommPort port = organisateur.getPort(portIndex);
		if (port == null)	{
			throw new Exception("Le port slectionn n'est pas ouvert");
		} 
		OutputStream res = port.getOutputStream();
		if (res == null) {
			throw new Exception("Le flot n'est pas accessible en criture");			
		}
		return res;
	}
	
	private void envoieTexte(OutputStream flot, String texte) {
		System.out.println("Texte:"+texte);
		PrintWriter pw = new PrintWriter(new OutputStreamWriter(flot));
		pw.println(texte);
		pw.close();
	}
}
